<?php
if (!defined("STRESSWEB"))
        die("Access denied...");
ob_start();

//-----------------------------------   ----------------------------

//URL  nextpay,     XML,      ..
define('NEXTPAY_XML_CLIENT_SERVER_URL', 'http://nextpay.ru/shop/shop/index.php');

//  .     nextpay
define('NEXTPAY_XML_CLIENT_SELLER_SECRET_KEY', '');

//ID .     nextpay
define('NEXTPAY_XML_CLIENT_PRODUCT_ID', '');

//   .    ,    <= 0
define('NEXTPAY_XML_CLIENT_SERVER_TIMEOUT', 60);



// 
define('NEXTPAY_XML_CLIENT_REQUEST_CHARACTER_SET', 'windows-1251');

// 
define('NEXTPAY_XML_CLIENT_RESPONSE_CHARACTER_SET', 'windows-1251');



//    (NEXTPAY_XML_CLIENT_EMBEDDED == true) 
//,    (NEXTPAY_XML_CLIENT_EMBEDDED == false)
define('NEXTPAY_XML_CLIENT_EMBEDDED', false);


//   
define('NEXTPAY_XML_CLIENT_ECHO_IN_STRING', false);


//    .    
define('NEXTPAY_XML_CLIENT_DEFAULT_CURRENCY', 2);//WMR

//     
define('NEXTPAY_XML_CLIENT_REQ_FIELD_MARK', '*');

//CSS      
define('NEXTPAY_XML_CLIENT_ERROR_CSS_STYLE', "style='color:red'");

//-----------------------------------    ----------------------------

// .  !
define('NEXTPAY_XML_CLIENT_SOURCE_SCRIPT_CHARACTER_SET', 'windows-1251');


//ID  --  !
define('NEXTPAY_XML_CLIENT_ACTION_BUY', 1);
define('NEXTPAY_XML_CLIENT_ACTION_RECALC', 2);

//    --   
define('NEXTPAY_XML_CLIENT_PRODUCT_PRICE_CURRENCY', '.');

//      ID 
//      2       WMR
//      3       WMZ
//      5       Yandex Money
//      6       WMU
//      7       WME
//      9       PLIMUS
//      10       Paymer R
//      11       Paymer Z
//      12       Paymer U
//      13      Kiwi
//      14       Yandex Money
//      15       RBK Money
//      16       Money Mail
//      17        
//      18       RUR WebCreds
//      19        
//  22  .    .

//ID    !
define('NEXTPAY_XML_CLIENT_BEELINE_CURRENCY', 19);
define('NEXTPAY_XML_CLIENT_WMR_TERM_CURRENCY', 21);
define('NEXTPAY_XML_CLIENT_KIWI_MOBILE_CURRENCY', 22);

//        .  !
define('NEXTPAY_CORE_KIWI_XML_API_TO_ACCOUNT_LEN', 10);


//   nextpay.  !
define('NEXTPAY_XML_API_ERROR_INTERNAL_ERROR', -1);
define('NEXTPAY_XML_API_ERROR_SUCCESS', 0);
define('NEXTPAY_XML_API_ERROR_PRODUCT_ID_NOT_PASSED', 1);
define('NEXTPAY_XML_API_ERROR_PRODUCT_NOT_FOUND', 2);
define('NEXTPAY_XML_API_ERROR_INVALID_PRICE_VALUE', 3);
define('NEXTPAY_XML_API_ERROR_PRODUCT_CURRENCY_DISABLED', 4);
define('NEXTPAY_XML_API_ERROR_ORDER_COST_INVALID', 5);
define('NEXTPAY_XML_API_ERROR_MIN_ORDER_COST', 6);
define('NEXTPAY_XML_API_ERROR_REQ_PARAM_NOT_PASSED', 7);
define('NEXTPAY_XML_API_ERROR_VALIDATION_BY_SELLER_FAILED', 8);
define('NEXTPAY_XML_API_ERROR_CURRENCY_NOT_SUPPORTED', 9);
define('NEXTPAY_XML_API_ERROR_CURRENCY_NOT_PASSED', 10);
define('NEXTPAY_XML_API_ERROR_CHECK_SUM', 11);
define('NEXTPAY_XML_API_ERROR_ORDER_COST_GENERAL_INVALID', 12);
define('NEXTPAY_XML_API_ERROR_INVALID_PRODUCT_COUNT_VALUE', 13);
define('NEXTPAY_XML_API_ERROR_INVALID_KIWI_BILL_TO_ACCOUNT', 14);

// !
define('NEXTPAY_XML_API_ATTR_TYPE_INT', 1);
define('NEXTPAY_XML_API_ATTR_TYPE_STRING', 2);
define('NEXTPAY_XML_API_ATTR_TYPE_ARRAY', 3);

define('NEXTPAY_XML_API_MILTI_OPTIONS_SEPATATOR', ";");


$nextpayXMLClientResponse = "";

//"" 
function nextpayXMLClient_Main()
{
        if(!NEXTPAY_XML_CLIENT_EMBEDDED && !NEXTPAY_XML_CLIENT_ECHO_IN_STRING)
        {

                header("Content-type: text/html;charset=".NEXTPAY_XML_CLIENT_RESPONSE_CHARACTER_SET);

                //  

                // expires in the past
                header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");

                // Last modified, right now
                header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");

                // Prevent caching, HTTP/1.1
                header("Cache-Control: no-cache, must-revalidate");

                // Prevent caching, HTTP/1.0
                header("Pragma: no-cache");

                nextpayXMLClient_echoContent("<html><head></head><body>");
        }
        $action = null;
        nextpayXMLClient_getRequestIntegerValue("nextpayXMLClient_action", "", $action, false);
        switch ($action)
        {
                case NEXTPAY_XML_CLIENT_ACTION_BUY:
                        {
                                if(!nextpayXMLClient_buyRequest())
                                {
                                        nextpayXMLClient_showForm();
                                }
                                break;
                        }
                case NEXTPAY_XML_CLIENT_ACTION_RECALC:
                        {
                                nextpayXMLClient_showForm();
                                break;
                        }
                default:
                        {
                                nextpayXMLClient_showForm();
                                break;
                        }
        }
        if(!NEXTPAY_XML_CLIENT_EMBEDDED)
        {
                nextpayXMLClient_echoContent("</body></html>");
        }
}

/**
 *        nextpay.ru
 *
 */
function nextpayXMLClient_buyRequest()
{
        $errorMessage = null;
        $productData = nextpayXMLClient_getProductData($errorMessage);
        if($productData == null)
        {
                if($errorMessage == null)
                {
                        $errorMessage = "     ";
                }
                nextpayXMLClient_errorMessage($errorMessage);
                return false;
        }
        $key  = "error";
        if(array_key_exists($key, $productData))
        {
                $errorMessage = $productData['error'];
                nextpayXMLClient_errorMessage($errorMessage);
                return false;
        }
        $productName = $productData['name'];
        $productPrice = $productData['price'];
        $productCountable = $productData['countable'];
        $beelineNumber = $productData['beeline_number'];

        $currencyId = null;
        if(!nextpayXMLClient_getRequestIntegerValue("nextpayXMLClient_currency", "", $currencyId, true))
        {
                return false;
        }

        $errorMessage = null;
        $rates = nextpayXMLClient_getRates($errorMessage);
        if($rates == null)
        {
                if($errorMessage == null)
                {
                        $errorMessage = "      ";
                }
                nextpayXMLClient_errorMessage($errorMessage);
                return false;
        }
        if(!array_key_exists($currencyId, $rates))
        {
                $errorMessage = " ID  : $currencyId";
                nextpayXMLClient_errorMessage($errorMessage);
                return false;
        }

        $index = "rate";
        $currencyData = $rates[$currencyId];
        if(!array_key_exists($index, $currencyData))
        {
                $errorMessage = "     . ID  : $currencyId";
                nextpayXMLClient_errorMessage($errorMessage);
                return false;
        }

        $exchangeRate = $currencyData[$index];
        if($exchangeRate <= 0)
        {
                $errorMessage = "      . ID  : $currencyId";
                nextpayXMLClient_errorMessage($errorMessage);
                return false;
        }

        $quantity = 1;
        if($productCountable)
        {
                if(!nextpayXMLClient_getRequestIntegerValue("nextpayXMLClient_quantity", "", $quantity, true))
                {
                        return false;
                }
                if($quantity <= 0)
                {
                        $errorMessage = "   ''";
                        nextpayXMLClient_errorMessage($errorMessage);
                        return false;
                }
        }
        $cost = $quantity * $productPrice * $exchangeRate;
        $cost = nextpayXMLClient_formatCostValue($cost);
        if($cost <= 0)
        {
                $errorMessage = "   ";
                nextpayXMLClient_errorMessage($errorMessage);
                return false;
        }

        $url = NEXTPAY_XML_CLIENT_SERVER_URL."?command=xml_api";
        $hash = NEXTPAY_XML_CLIENT_PRODUCT_ID.$quantity.NEXTPAY_XML_CLIENT_SELLER_SECRET_KEY;
        $hash = sha1($hash);
        $url .= "&hash=$hash&quantity=$quantity&product_id=".NEXTPAY_XML_CLIENT_PRODUCT_ID."&volute=$currencyId";
        switch ($currencyId)
        {
                case NEXTPAY_XML_CLIENT_KIWI_MOBILE_CURRENCY:
                        {
                                $kiwiBillToAccount = nextpayXMLClient_getRequestValue("nextpayXMLClient_kiwi_bill_to_account");
                                $kiwiBillToAccount = nextpayXMLClient_prepareURLParam($kiwiBillToAccount);
                                $url .= "&kiwi_bill_to_account=$kiwiBillToAccount";
                                break;
                        }
                case NEXTPAY_XML_CLIENT_WMR_TERM_CURRENCY:
                        {
                                $param = nextpayXMLClient_getRequestValue("nextpayXMLClient_pay_code");
                                $param = nextpayXMLClient_prepareURLParam($param);
                                $url .= "&pay_code=$param";

                                $param = nextpayXMLClient_getRequestValue("nextpayXMLClient_atm_kiosk_id");
                                $param = nextpayXMLClient_prepareURLParam($param);
                                $url .= "&atm_kiosk_id=$param";

                                $param = nextpayXMLClient_getRequestValue("nextpayXMLClient_atm_date_d");
                                $param = nextpayXMLClient_prepareURLParam($param);
                                $url .= "&atm_date_d=$param";

                                $param = nextpayXMLClient_getRequestValue("nextpayXMLClient_atm_date_m");
                                $param = nextpayXMLClient_prepareURLParam($param);
                                $url .= "&atm_date_m=$param";

                                $param = nextpayXMLClient_getRequestValue("nextpayXMLClient_atm_date_y");
                                $param = nextpayXMLClient_prepareURLParam($param);
                                $url .= "&atm_date_y=$param";

                                break;

                        }
        }
        nextpayXMLClient_getFormAttributes($productData, $url);
        $response = nextpayXMLClient_getServerResponse($url);
        if($response == null)
        {
                return false;
        }
        else
        {
                $result = $response['result'];
                $data = $response['data'];
                $comment = $response['comment'];
                switch ($result)
                {
                        case NEXTPAY_XML_API_ERROR_SUCCESS:
                                {
                                        switch($currencyId)
                                        {
                                                case NEXTPAY_XML_CLIENT_KIWI_CURRENCY:
                                                        {
                                                                nextpayXMLClient_printKIWIOrder(
                                                                $data,
                                                                $productPrice,
                                                                $cost,
                                                                $productCountable,
                                                                $exchangeRate,
                                                                $productName);
                                                                break;
                                                        }
                                                case NEXTPAY_XML_CLIENT_BEELINE_CURRENCY:
                                                        {
                                                                $data = nextpayXMLClient_convFromUTF($data);
                                                                nextpayXMLClient_printBeelineOrder($data, $beelineNumber);
                                                                break;
                                                        }
                                                case NEXTPAY_XML_CLIENT_KIWI_MOBILE_CURRENCY:
                                                        {
                                                                $data = nextpayXMLClient_convFromUTF($data);
                                                                nextpayXMLClient_printKIWIBill($data);
                                                                break;
                                                        }
                                                default:
                                                        {
                                                                echo "<script>location.href=\"$data\";</script>";
                                                                break;
                                                        }
                                        }
                                        return true;
                                }
                        default:
                                {
                                        $errorMessage = "$comment  : $result";
                                        $errorMessage = nextpayXMLClient_htmlEncode($errorMessage);
                                        nextpayXMLClient_errorMessage($errorMessage);
                                        return false;
                                }
                }
        }
}

// 
function nextpayXMLClient_showForm()
{
        $errorMessage = null;
        $productData = nextpayXMLClient_getProductData($errorMessage);
        if($productData == null)
        {
                if($errorMessage == null)
                {
                        $errorMessage = "     ";
                }
                nextpayXMLClient_errorMessage($errorMessage);
                return;
        }
        $key = 'error';
        if(array_key_exists($key, $productData))
        {
                $errorMessage = $productData['error'];
                nextpayXMLClient_errorMessage($errorMessage);
                return;
        }
        $productName = $productData['name'];
        $productPrice = $productData['price'];
        $productCountable = $productData['countable'];

        $action = null;
        nextpayXMLClient_getRequestIntegerValue("nextpayXMLClient_action", "", $action, false);
        $initAction = $action != NEXTPAY_XML_CLIENT_ACTION_BUY && $action != NEXTPAY_XML_CLIENT_ACTION_RECALC;

        $priceCurrency = NEXTPAY_XML_CLIENT_PRODUCT_PRICE_CURRENCY;
        $currencyId = null;
        if(!nextpayXMLClient_getRequestIntegerValue("nextpayXMLClient_currency", "", $currencyId, false))
        {
                $currencyId = NEXTPAY_XML_CLIENT_DEFAULT_CURRENCY;
        }

        $errorMessage = null;
        $rates = nextpayXMLClient_getRates($errorMessage);
        if($rates == null)
        {
                if($errorMessage == null)
                {
                        $errorMessage = "      ";
                }
                nextpayXMLClient_errorMessage($errorMessage);
                return;
        }

        if(!array_key_exists($currencyId, $rates))
        {
                $errorMessage = " ID  : $currencyId";
                nextpayXMLClient_errorMessage($errorMessage);
                return;
        }

        $currencyData = $rates[$currencyId];
        $index = "rate";
        if(!array_key_exists($index, $currencyData))
        {
                $errorMessage = "     . ID : $currencyId";
                nextpayXMLClient_errorMessage($errorMessage);
                return;
        }
        $exchangeRate = $currencyData[$index];
        if($exchangeRate <= 0)
        {
                $errorMessage = "      . ID : $currencyId";
                nextpayXMLClient_errorMessage($errorMessage);
                return;
        }
        $exchangeRateRev = 1 / $exchangeRate;
        $exchangeRateRev = nextpayXMLClient_formatCostValue($exchangeRateRev);

        $index = "description";
        $currencyDescr = $currencyData[$index];
        $currencyDescr = nextpayXMLClient_htmlEncode($currencyDescr);
        nextpayXMLClient_onQuantityChangeJS($productPrice, $exchangeRate, $currencyDescr);

        nextpayXMLClient_onCurrencyChangeJS();

        $quantity = null;
        if($productCountable)
        {
                if(!nextpayXMLClient_getRequestIntegerValue("nextpayXMLClient_quantity", "", $quantity, false))
                {
                        if($initAction)
                        {
                                $quantity = 1;
                        }
                }
        }
        else
        {
                $quantity = 1;
        }
        $cost = null;
        if($quantity != null)
        {
                $cost = $exchangeRate * $quantity * $productPrice;
                $cost = nextpayXMLClient_formatCostValue($cost). " ".$currencyDescr. " ( $exchangeRateRev)";
        }
        $actionParam = NEXTPAY_XML_CLIENT_ACTION_BUY;
        $reqFieldMark = NEXTPAY_XML_CLIENT_REQ_FIELD_MARK;
        nextpayXMLClient_echoContent("

        <form name='nextpayXMLClient_buy_form' method='post' autocomplete='off'>
        <input type='hidden' name='nextpayXMLClient_action' value='$actionParam'/>");
        switch ($currencyId)
        {
                case NEXTPAY_XML_CLIENT_KIWI_MOBILE_CURRENCY;
                {
                        nextpayXMLClient_kiwiBillForm();
                        nextpayXMLClient_echoContent("<p/>");
                        break;
                }
                case NEXTPAY_XML_CLIENT_WMR_TERM_CURRENCY:
                        {
                                nextpayXMLClient_wmTermForm($productData);
                                nextpayXMLClient_echoContent("<p/>");
                                break;
                        }
        }
        nextpayXMLClient_echoContent("<table cellpadding='5' cellspacing='0'>
        <tr>
                <td>
                        
                </td>
                <td>
                        $productName
                </td>
        </tr>
        <tr>
                <td>
                        
                </td>
                <td>
                        $productPrice $priceCurrency
                </td>
        </tr>");
        nextpayXMLClient_showFormAttributes($productData);
        if($productCountable)
        {
                nextpayXMLClient_echoContent("<tr>
                <td>
                         $reqFieldMark$reqFieldMark
                </td>
                <td>
                        <input
                                onkeyup=\"nextpayXMLClient_onQuantityChange(this)\" 
                                type='text' 
                                id='nextpayXMLClient_quantity' 
                                name='nextpayXMLClient_quantity' 
                                maxlength='6' 
                                value=\"$quantity\"/>
                </td>
        </tr>");
        }
        nextpayXMLClient_echoContent("<tr>
                <td>
                        
                </td>
                <td>");
        nextpayXMLClient_showRatesHTML($rates, $currencyId);
        nextpayXMLClient_echoContent("</td>
        </tr>");
        nextpayXMLClient_echoContent("
        <tr>
                <td>
                        
                </td>
                <td>
                        <div id='nextpayXMLClient_order_cost'>$cost</div>");
        nextpayXMLClient_echoContent("</td>
                </tr>
                </table>
                <p>
                        <input class='forms_submit' type='submit' value=''/> 
                </p>
        </form>
        <hr/>
        $reqFieldMark    
        <br/>
        $reqFieldMark$reqFieldMark   \"\". 
                 \"\"   
        <br/>$reqFieldMark$reqFieldMark$reqFieldMark       ");
}

/**
 *     URL  
 *
 * @param string $url URL 
 * @param int $maxlength   
 * @param int $timeout   .   > 0  -1,  .
 *  == -1,    NEXTPAY_XML_CLIENT_SERVER_TIMEOUT
 * @param bool $disableWarnings     
 * @return string    FALSE   
 */
function nextpayXMLClient_getFileContentByURL($url, $maxlength = null, $timeout = -1, $disableWarnings = true)
{
        if($timeout == -1)
        {
                $timeout = NEXTPAY_XML_CLIENT_SERVER_TIMEOUT;
        }
        $ret = null;
        $cxContext = null;
        if($timeout > 0)
        {
                ini_set('default_socket_timeout', $timeout);
        }
        if($disableWarnings)
        {
                error_reporting(E_ERROR);
        }
        if($maxlength == null)
        {
                $ret = file_get_contents($url, False, $cxContext);
        }
        else
        {
                $ret = file_get_contents($url, False, $cxContext, 0, $maxlength);
        }
        if($ret !== FALSE)
        {
                if($ret != null)
                {
                        $ret = trim($ret);
                }
        }
        return $ret;
}


function nextpayXMLClient_getRates(&$errorMessage)
{
        $url = NEXTPAY_XML_CLIENT_SERVER_URL."?command=rates_product_xml&product_id=".NEXTPAY_XML_CLIENT_PRODUCT_ID;
        $xml = nextpayXMLClient_getFileContentByURL($url);
        if($xml === FALSE)
        {
                $errorMessage = "      ";
                return null;
        }
        $vals = null;
        $index = null;
        $p = xml_parser_create();
        xml_parse_into_struct($p, $xml, $vals, $index);
        xml_parser_free($p);
        $ret = array();
        $currencyId = null;
        $currencyName = null;
        $currencyRate = null;
        $currencyDesc = null;
        foreach ($vals as $key => $value)
        {
                $array = $value;
                $tagName = $array['tag'];
                $tagName = strtolower($tagName);
                switch($tagName)
                {
                        case "id":
                                {
                                        $currencyId = $array['value'];
                                        $currencyId = intval($currencyId);
                                        $currencyData = array();
                                        $currencyData['name'] = $currencyName;
                                        $currencyData['rate'] = $currencyRate;
                                        $currencyData['description'] = $currencyDesc;
                                        $ret[$currencyId] = $currencyData;
                                        break;
                                }
                        case "name":
                                {
                                        $currencyName = $array['value'];
                                        $currencyName = nextpayXMLClient_convFromUTF($currencyName);
                                        break;
                                }
                        case "rate":
                                {
                                        $currencyRate = $array['value'];
                                        break;
                                }
                        case "description":
                                {
                                        $currencyDesc = $array['value'];
                                        $currencyDesc = nextpayXMLClient_convFromUTF($currencyDesc);
                                        break;
                                }
                        case "error":
                                {
                                        $errorMessage = $array['value'];
                                        $errorMessage = nextpayXMLClient_convFromUTF($errorMessage);
                                        return null;
                                }
                        default:
                                {
                                        break;
                                }
                }
        }
        return $ret;
}

function nextpayXMLClient_getProductData(&$errorMessage)
{
        $url = NEXTPAY_XML_CLIENT_SERVER_URL."?command=product_xml&product_id=".NEXTPAY_XML_CLIENT_PRODUCT_ID;
        $xml = nextpayXMLClient_getFileContentByURL($url);
        if($xml === FALSE)
        {
                $errorMessage = "     ";
                return null;
        }
        $vals = null;
        $index = null;
        $p = xml_parser_create();
        xml_parse_into_struct($p, $xml, $vals, $index);
        xml_parser_free($p);
        $ret = array();
        $formAttributes = array();
        $formAttribuiteId = null;
        foreach ($vals as $key => $value)
        {
                $array = $value;
                $tagName = $array['tag'];
                $tagName = strtolower($tagName);
                switch($tagName)
                {
                        case "price":
                                {
                                        $productPrice = $array['value'];
                                        $productPrice = nextpayXMLClient_formatCostValue($productPrice);
                                        $ret['price'] = $productPrice;
                                        break;
                                }
                        case "countable":
                        case "name":
                        case "beeline_prefix":
                        case "beeline_number":
                        case "wm_term_form":
                        case "error":
                                {
                                        $value = $array['value'];
                                        $value = nextpayXMLClient_convFromUTF($value);
                                        $ret[$tagName] = $value;
                                        break;
                                }
                        case "form-attribute":
                                {
                                        $key = 'attributes';
                                        if(array_key_exists($key, $array))
                                        {
                                                $formAttribuiteId = $array[$key]['ID'];
                                                $attributeData = array();
                                                $attributeData['id'] =  $formAttribuiteId;
                                                $attributeData['type'] =  $array[$key]['TYPE'];
                                                $attributeData['required'] =  $array[$key]['REQUIRED'];
                                                $attributeData['name'] =  $array[$key]['NAME'];
                                                $attributeData['hidden'] =  $array[$key]['HIDDEN'];
                                                $formAttributes[$formAttribuiteId] = $attributeData;
                                        }
                                        break;
                                }
                        case "form-attribute-label":
                        case "form-attribute-default-value":
                        case "form-attribute-values-array":
                        case "form-attribute-labels-array":
                                {
                                        if(array_key_exists($formAttribuiteId, $formAttributes))
                                        {
                                                $attributeData = $formAttributes[$formAttribuiteId];
                                                $val = $array['value'];
                                                $val = nextpayXMLClient_convFromUTF($val);
                                                $attributeData[$tagName] = $val;
                                                $formAttributes[$formAttribuiteId] = $attributeData;
                                        }
                                        break;
                                }
                        default:
                                {
                                        break;
                                }
                }
        }
        $ret['form_attributes'] = $formAttributes;
        return $ret;
}

function nextpayXMLClient_getFormAttributes($productData, &$url)
{
        $formAttributes = $productData['form_attributes'];
        foreach ($formAttributes as $key => $row)
        {
                $attrName = $row["name"];
                $attrName = urlencode($attrName);
                $attrValue = nextpayXMLClient_getRequestValue($attrName);
                $attrValue = nextpayXMLClient_prepareURLParam($attrValue);
                $url .= "&$attrName=$attrValue";
        }
}

function nextpayXMLClient_showFormAttributes($productData)
{
        $formAttributes = $productData['form_attributes'];
        $reqField = NEXTPAY_XML_CLIENT_REQ_FIELD_MARK;
        foreach ($formAttributes as $key => $row)
        {
                $attrId = $key;
                $attrId = intval($attrId);

                $attrType = $row["type"];
                $attrType = intval($attrType);

                $attrRequired = $row["required"];
                $attrRequired = intval($attrRequired);

                $attrHidden = $row["hidden"];
                $attrHidden = intval($attrHidden);

                $attrName = $row["name"];
                $attrName = nextpayXMLClient_htmlEncode($attrName);

                $attrLabel = $row["form-attribute-label"];
                $attrLabel = nextpayXMLClient_htmlEncode($attrLabel);

                $attrDefaultValue = $row["form-attribute-default-value"];
                $attrDefaultValue = nextpayXMLClient_htmlEncode($attrDefaultValue);

                $attrValues = $row["form-attribute-values-array"];

                $attrLabels = $row["form-attribute-labels-array"];

                $attrValue = nextpayXMLClient_getRequestValue($attrName, false);
                if($attrValue == null)
                {
                        $attrValue = $attrDefaultValue;
                }
                $attrValueEnc = nextpayXMLClient_htmlEncode($attrValue);

                if($attrHidden)
                {
                        nextpayXMLClient_echoContent("<tr><td>
                                <input type=\"hidden\" id=\"$attrName\" name=\"$attrName\" value=\"$attrValueEnc\"/>
                        </td></tr>");
                }
                else
                {
                        nextpayXMLClient_echoContent("<tr><td>$attrLabel");
                        if($attrRequired)
                        {
                                nextpayXMLClient_echoContent(" ");
                                nextpayXMLClient_echoContent($reqField);
                        }
                        nextpayXMLClient_echoContent("</td><td>");
                        switch ($attrType)
                        {
                                case NEXTPAY_XML_API_ATTR_TYPE_ARRAY:
                                        {
                                                nextpayXMLClient_showSelectOptions($attrName, $attrValue, $attrValues, $attrLabels, $attrLabel);
                                                break;
                                        }
                                default:
                                        {
                                                nextpayXMLClient_echoContent(
                                                "<input title=\"$attrLabel\" id=\"$attrName\" name=\"$attrName\" value=\"$attrValueEnc\"/>");
                                                break;
                                        }
                        }
                        nextpayXMLClient_echoContent("</td></tr>");
                }
        }
}

function nextpayXMLClient_getMiltiValues($string)
{
        $ret = explode(NEXTPAY_XML_API_MILTI_OPTIONS_SEPATATOR, $string);
        return $ret;
}

function nextpayXMLClient_showSelectOptions($attrName, $selectedValue, $valuesString, $labelsString, $attrLabel)
{
        $values = nextpayXMLClient_getMiltiValues($valuesString);
        $labels = nextpayXMLClient_getMiltiValues($labelsString);
        if(count($values) == count($labels))
        {
                $attrName = nextpayXMLClient_htmlEncode($attrName);
                $selectedValueEnc = nextpayXMLClient_htmlEncode($selectedValue);
                nextpayXMLClient_echoContent(
                "<select title=\"$attrLabel\" id=\"$attrName\" name=\"$attrName\" value=\"$selectedValueEnc\">");
                for($i = 0; $i < count($values); $i++)
                {
                        $label = $labels[$i];
                        $label = nextpayXMLClient_htmlEncode($label);
                        $value = $values[$i];
                        $valueEnc = nextpayXMLClient_htmlEncode($value);
                        nextpayXMLClient_echoContent("<option value=\"$valueEnc\"");
                        if($selectedValue == $value)
                        {
                                nextpayXMLClient_echoContent(" selected ");
                        }
                        nextpayXMLClient_echoContent(">$label</option>");
                }
                nextpayXMLClient_echoContent("</select>");
        }
        else
        {
                nextpayXMLClient_echoContent("nextpayXMLClient_showSelectOptions error.
                Labels count != Values count");
        }
}

function nextpayXMLClient_getServerResponse($url)
{
        $xml = nextpayXMLClient_getFileContentByURL($url);
        if($xml === FALSE)
        {
                nextpayXMLClient_errorMessage("     ");
                return null;
        }
        $vals = null;
        $index = null;
        $p = xml_parser_create();
        xml_parse_into_struct($p, $xml, $vals, $index);
        xml_parser_free($p);
        $ret = array();
        foreach ($vals as $key => $value)
        {
                $array = $value;
                $tagName = $array['tag'];
                $tagName = strtolower($tagName);
                switch($tagName)
                {
                        case "result":
                                {
                                        $result = $array['value'];
                                        $result = intval($result);
                                        $ret['result'] = $result;
                                        break;
                                }
                        case "data":
                                {
                                        $data = $array['value'];
                                        $ret['data'] = $data;
                                        break;
                                }
                        case "comment":
                                {
                                        $comment = $array['value'];
                                        $comment = nextpayXMLClient_convFromUTF($comment);
                                        $ret['comment'] = $comment;
                                        break;
                                }
                        default:
                                {
                                        break;
                                }
                }
        }
        return $ret;
}





function nextpayXMLClient_convFromUTF($text)
{
        $text = iconv("UTF-8", NEXTPAY_XML_CLIENT_SOURCE_SCRIPT_CHARACTER_SET, $text);
        return $text;
}

function nextpayXMLClient_showRatesHTML($rates, $selectedCurrencyId)
{
        nextpayXMLClient_echoContent("<select  name='nextpayXMLClient_currency'  onchange='nextpayXMLClient_onCurrencyChange()'>");
        foreach ($rates as $key => $value)
        {
                $array = $value;
                $currencyName = $array['name'];
                $currencyName = nextpayXMLClient_htmlEncode($currencyName);
                $currencyRate = $array['rate'];
                $currencyRate = 1 / $currencyRate;
                $currencyRate = nextpayXMLClient_formatCostValue($currencyRate);
                if($selectedCurrencyId == $key)
                {
                        nextpayXMLClient_echoContent("<option value='$key' selected>$currencyName</option>");
                }
                else
                {
                        nextpayXMLClient_echoContent("<option value='$key'>$currencyName</option>");
                }
        }
        nextpayXMLClient_echoContent("</select>");
}


/**
 *      
 * 
 * @param string $name    
 * @param string $fieldName     
 * @param boolean $mySQLEscape     ,
 * c  mysql_escape_string  
 * @param  ,   
 *       
 * @return bool true   , false   
 */
function nextpayXMLClient_getRequestIntegerValue($name, $fieldName, &$value, $printErrorMessage = true)
{
        $value = nextpayXMLClient_getRequestStringValue($name, $fieldName, true, $printErrorMessage);
        if($value == null)
        {
                return false;
        }
        else
        {
                if($value == "0")
                {
                        $value = 0;
                        return true;
                }
                else
                {
                        $value = intval($value);
                        if($value == 0)
                        {
                                if($printErrorMessage)
                                {
                                        nextpayXMLClient_errorMessage(" '".$fieldName."'  !");
                                }
                                return false;
                        }
                        else
                        {
                                return true;
                        }
                }
        }
}

function nextpayXMLClient_getRequestValue($paramName, $trimInput = true)
{
        if(isset($_REQUEST[$paramName]))
        {
                $ret =  $_REQUEST[$paramName];
                if($ret != NULL)
                {
                        if($trimInput)
                        {
                                $ret = trim($ret);
                        }
                }
                $ret = iconv(NEXTPAY_XML_CLIENT_REQUEST_CHARACTER_SET, NEXTPAY_XML_CLIENT_SOURCE_SCRIPT_CHARACTER_SET, $ret);
                return $ret;
        }
        else
        {
                return NULL;
        }
}

function nextpayXMLClient_getRequestStringValue($name, $fieldName, $trimInput = true, $printErrorMessage = true)
{
        $value = nextpayXMLClient_getRequestValue($name, $trimInput);
        $ret = nextpayXMLClient_checkStringValue($value, $fieldName, $printErrorMessage);
        if($ret)
        {
                return $value;
        }
        else
        {
                return null;
        }
}

function nextpayXMLClient_checkStringValue($value, $fieldName, $printErrorMessage = true)
{
        if($value == "" || $value == null)
        {
                if($printErrorMessage)
                {
                        nextpayXMLClient_errorMessage (" '".$fieldName."'  !");
                }
                return false;
        }
        else
        {
                return true;
        }
}

function nextpayXMLClient_htmlEncode($string)
{
        return htmlentities($string, ENT_COMPAT, NEXTPAY_XML_CLIENT_SOURCE_SCRIPT_CHARACTER_SET);
}


function nextpayXMLClient_errorMessage($message)
{
        $cssStyle = NEXTPAY_XML_CLIENT_ERROR_CSS_STYLE;
        nextpayXMLClient_echoContent("<span $cssStyle>$message</span>");
}

function nextpayXMLClient_formatCostValue($value)
{
        return number_format($value, 2, '.', '');
}

function nextpayXMLClient_onQuantityChangeJS($productPrice, $exchangeRate, $currencyDescr)
{
        $exchangeRateRev = 1 / $exchangeRate;
        $exchangeRateRev = nextpayXMLClient_formatCostValue($exchangeRateRev);
        nextpayXMLClient_echoContent("
        <script>
        function nextpayXMLClient_onQuantityChange(obj)
        {
                var price = $productPrice;
                var rate = $exchangeRate;
                var form = document.forms['nextpayXMLClient_buy_form'];
                var formElements = form.elements;
                var costElement = document.getElementById('nextpayXMLClient_order_cost');
                if(obj.value == '')
                {
                        costElement.innerHTML = '&nbsp;';
                }
                else if(isNaN(obj.value))
                {
                        costElement.innerHTML = '&nbsp;';
                }
                else if(obj.value <= 0)
                {
                        costElement.innerHTML = '&nbsp;';
                }
                else
                {
                        var costValue =  (obj.value * price) * rate;
                        costValue = costValue.toFixed(2);
                        costElement.innerHTML = costValue + ' $currencyDescr ( $exchangeRateRev)';
                }
        }
        </script>");
}

function nextpayXMLClient_onCurrencyChangeJS()
{
        $action = NEXTPAY_XML_CLIENT_ACTION_RECALC;
        nextpayXMLClient_echoContent("
        <script>
        function nextpayXMLClient_onCurrencyChange()
        {
                var form = document.forms['nextpayXMLClient_buy_form'];
                form.elements['nextpayXMLClient_action'].value='$action'; 
                form.submit();
        }
        </script>");
}

function nextpayXMLClient_printKIWIOrder($orderId, $productPrice, $cost, $productCountable, $exchRate, $productName)
{
        $orderId = nextpayXMLClient_htmlEncode($orderId);
        $priceCurrencyName = NEXTPAY_XML_CLIENT_PRODUCT_PRICE_CURRENCY;
        $productPriceRated = $productPrice * $exchRate;
        $productPriceRated = nextpayXMLClient_formatCostValue($productPriceRated);
        nextpayXMLClient_echoContent("
        <p>
                  !         .
        </p>
        <p>     
                <strong>
                             : <b>$orderId</b>
                </strong>
        </p>");
        if($productCountable)
        {
                nextpayXMLClient_echoContent("
                <p>
                            ,      $productPriceRated 
                        $priceCurrencyName  $productName.      $productName.
                </p>"); 
        }
        else
        {
                nextpayXMLClient_echoContent("
                <p>
                                 $cost $priceCurrencyName
                </p>");     
        }
        nextpayXMLClient_echoContent("
        <p>
                         <b>$orderId</b>  ,     nextpay.ru  .
        </p>
        <p>
                             
                <a target='_blank' href='http://www.osmp.ru/'>http://www.osmp.ru/</a>
        </p>");
}

function nextpayXMLClient_printBeelineOrder($data, $number)
{
        nextpayXMLClient_echoContent("
        <p>
                    SMS c  <b>$data</b>   <b>$number</b>  
        </p>
        <p>
                SMS <b></b>,      .
        </p>
        <div style='border:1px solid black;padding: 4px;'>
        <p>
                    ,       .
        </p>    
        <p>
                                 ,      .
        </p>
        <p>
                              ,           .
        </p>
        <p>
                        10 .
        </p>
        <p>
                     <a target='_blank'  href='http://kvartplata.beeline.ru/common.do'></a>.
        </p>
        </div>
        ");
}

function nextpayXMLClient_printKIWIBill($data)
{
        nextpayXMLClient_echoContent($data);
        $currencyId = NEXTPAY_XML_CLIENT_KIWI_MOBILE_CURRENCY;
        nextpayXMLClient_echoContent("
                <p>
                <form method='post'>
                        <input type='hidden' name='nextpayXMLClient_currency' value='$currencyId'/>
                        <input type='submit' value=' '/>
                </form>
        </p>");
}



function nextpayXMLClient_kiwiBillForm()
{
        $inputName =  "nextpayXMLClient_kiwi_bill_to_account";
        $toAccountLen = NEXTPAY_CORE_KIWI_XML_API_TO_ACCOUNT_LEN;
        $toAccount = nextpayXMLClient_getRequestValue($inputName);
        $toAccount = nextpayXMLClient_htmlEncode($toAccount);
        $reqSymbol = NEXTPAY_XML_CLIENT_REQ_FIELD_MARK;
        nextpayXMLClient_echoContent(
        "<table border='0' style='border: 1px solid black' cellpadding='5'>
                <tr>
                        <td>
                                  $reqSymbol
                        </td>
                </tr>                                   
                <tr>
                        <td>
                                <table border='0' style='width:100%' cellpadding='0' cellspacing='0'>
                                        <tr>
                                                <td style='width:15px'>8</td>
                                        <td>
                                        <input 
                                        style='width:100%' 
                                        maxlength='$toAccountLen' 
                                        type=\"text\" 
                                        name=\"$inputName\" 
                                        value=\"$toAccount\"/>                                          
                                        </td>
                                </tr>
                        </table>        
                </td>
                </tr>
                <tr>
                        <td>
                                     ( ,     )
                                (     QIWI.       , 
                                         SMS    
                                    ).                                    
                        </td>
                </tr>                                   
        </table>
        ");
}

function nextpayXMLClient_wmTermForm($productData)
{
        $reqSymbol = NEXTPAY_XML_CLIENT_REQ_FIELD_MARK;

        $payCode = nextpayXMLClient_getRequestValue("nextpayXMLClient_pay_code");
        $payCode = nextpayXMLClient_htmlEncode($payCode);

        $atmDateD = nextpayXMLClient_getRequestValue("nextpayXMLClient_atm_date_d");
        $atmDateD = nextpayXMLClient_htmlEncode($atmDateD);

        $atmDateM = nextpayXMLClient_getRequestValue("nextpayXMLClient_atm_date_m");
        $atmDateM = nextpayXMLClient_htmlEncode($atmDateM);

        $atmDateY = nextpayXMLClient_getRequestValue("nextpayXMLClient_atm_date_y");
        $atmDateY = nextpayXMLClient_htmlEncode($atmDateY);

        $atmKioskId = nextpayXMLClient_getRequestValue("nextpayXMLClient_atm_kiosk_id");
        $atmKioskId = nextpayXMLClient_htmlEncode($atmKioskId);

        $form = $productData['wm_term_form'];
        $form = str_replace("%p1", $reqSymbol, $form);
        $form = str_replace("%p2", $payCode, $form);
        $form = str_replace("%p3", $atmKioskId, $form);
        $form = str_replace("%p4", $atmDateD, $form);
        $form = str_replace("%p5", $atmDateM, $form);
        $form = str_replace("%p6", $atmDateY, $form);

        nextpayXMLClient_echoContent($form);
}


function nextpayXMLClient_echoContent($string)
{
        if(NEXTPAY_XML_CLIENT_ECHO_IN_STRING)
        {
                global $nextpayXMLClientResponse;
                $nextpayXMLClientResponse .= $string;
        }
        else
        {
                $string = iconv(NEXTPAY_XML_CLIENT_SOURCE_SCRIPT_CHARACTER_SET, NEXTPAY_XML_CLIENT_RESPONSE_CHARACTER_SET, $string);
                echo $string;
        }
}

/**
 *         nextpay  URL
 *
 * nextpay        windows-1251! 
 * 
 * @param string $paramValue  (  )
 * @return string  
 */
function nextpayXMLClient_prepareURLParam(&$paramValue)
{
        $paramValue = iconv(NEXTPAY_XML_CLIENT_SOURCE_SCRIPT_CHARACTER_SET, 'windows-1251', $paramValue);
        $paramValue = urlencode($paramValue);
        return $paramValue;
}


//  
nextpayXMLClient_Main();
$tpl->SetResult( 'content', ob_get_clean() );
?>